// DEFINE.H : just some macros #defined here...

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef DEFINE_H
#define DEFINE_H

////////////////////////////////////////////////////////////////////////////////////////////////////

#define VERSION "0.0.997"
#define RELEASEDATE "10.5.2000"
#define WEBSITE "http://www.uku.fi/~thassine/ghemical"

////////////////////////////////////////////////////////////////////////////////////////////////////

#define NOT_DEFINED -1		// negative values often mean "not defined"...

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

// relative paths, for UNIX

#define MM1_STABLE_PATH "mm1data/stable/"
#define MM1_UNSTABLE_PATH "mm1data/unstable/"
#define MM1_AMINO_BUILDER_PATH "builder/amino.txt"
#define MM1_NUCLEIC_BUILDER_PATH "builder/nucleic.txt"

#define MM2_TOR_PATH "mm2data/looptor.txt"
#define MM2_DIP_PATH "mm2data/loopdip.txt"

////////////////////////////////////////////////////////////////////////////////////////////////////

// absolute paths, for UNIX (needed for parallel processing?!?!?!)

//#define MM1_STABLE_PATH "/home/thassine/test/mm1data/stable/"
//#define MM1_UNSTABLE_PATH "/home/thassine/test/mm1data/unstable/"
//#define MM1_AMINO_BUILDER_PATH "/home/thassine/test/builder/amino.txt"
//#define MM1_NUCLEIC_BUILDER_PATH "/home/thassine/test/builder/nucleic.txt"

//#define MM2_TOR_PATH "/home/thassine/test/mm2data/looptor.txt"
//#define MM2_DIP_PATH "/home/thassine/test/mm2data/loopdip.txt"

////////////////////////////////////////////////////////////////////////////////////////////////////

// relative paths, for Win32

//#define MM1_STABLE_PATH "mm1data\\stable\\"
//#define MM1_UNSTABLE_PATH "mm1data\\unstable\\"
//#define MM1_AMINO_BUILDER_PATH "builder\\amino.txt"
//#define MM1_NUCLEIC_BUILDER_PATH "builder\\nucleic.txt"

//#define MM2_TOR_PATH "mm2data\\looptor.txt"
//#define MM2_DIP_PATH "mm2data\\loopdip.txt"

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

// this is the common case, for Linux

#define BEGIN_INCLUDE_STL "lnx_stl_b.h"
#define END_INCLUDE_STL "lnx_stl_e.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

// this is for SGI-machines and fw-gcc-2.95.2 compiler

//#define BEGIN_INCLUDE_STL "sgi_stl_b.h"
//#define END_INCLUDE_STL "sgi_stl_e.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

#define GLNAME_LIGHT	0x0001
#define GLNAME_OBJECT	0x0002

#define GLNAME_MODEL_DEPENDENT 0xFF00		// all these events are forwarded...

#define GLNAME_MD_TYPE1 (GLNAME_MODEL_DEPENDENT | 0x01)
#define GLNAME_MD_TYPE2 (GLNAME_MODEL_DEPENDENT | 0x02)

////////////////////////////////////////////////////////////////////////////////////////////////////

// should these be made model-dependent ?!?!?!
// should these be made model-dependent ?!?!?!
// should these be made model-dependent ?!?!?!

#define RENDER_NOTHING		0x00
#define RENDER_WIREFRAME	0x01
#define RENDER_BALL_AND_STICK	0x02
#define RENDER_VAN_DER_WAALS	0x03
#define RENDER_ACCESSIBLE	0x04
#define RENDER_CYLINDERS	0x05

#define LABEL_NOTHING		0x00
#define LABEL_ELEMENT		0x01
#define LABEL_BONDTYPE		0x02

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// DEFINE_H

// eof
