// MM1ALG.H : algorithms for mm1-models.

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef MM1ALG_H
#define MM1ALG_H

class mm1_geomopt;
class mm1_moldyn;

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "mm1eng.h"
#include "conjgrad.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

class mm1_geomopt : public conjugate_gradient
{
	public:
	
	mm1_eng * eng;
	
	public:
	
	mm1_geomopt(mm1_eng *);
	~mm1_geomopt(void);
	
	f32 GetValue(void);		// virtual
	f32 GetGradient(void);		// virtual
};

////////////////////////////////////////////////////////////////////////////////////////////////////

class mm1_moldyn
{
	public:
	
	mm1_eng * eng;
	
	f32 * vel;
	f32 * acc;
	
	f32 * mass;
	
	f32 temp;
	
	f32 step1; f32 step2;
	f32 kin; f32 pot;
	
	public:
	
	mm1_moldyn(mm1_eng *, f32, f32);
	~mm1_moldyn(void);
	
	void TakeMDStep(void);
	
	f32 KineticEnergy(void);
	
	f32 ConvTempEKin(f32);
	f32 ConvEKinTemp(f32);
	
	void SetEKin(f32);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// MM1ALG_H

// eof
