// NEURAL.H : neural network tools...

// Copyright (C) 1999 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef NEURAL_H
#define NEURAL_H

#include "typedef.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

class bp_network
{
	private:
	
	f32 Sigmoid(f32);
	f32 DSigmoid(f32);
	
	i32s size[3]; f32 ** iw; f32 ** hw;
	f32 * ha; f32 * oa; f32 * hd; f32 * hs;
	
	public:
	
	bp_network(i32s, i32s, i32s);
	~bp_network(void);
	
	void Randomize(f32);
	void ReadNetwork(const char *);
	void WriteNetwork(const char *);
	
	void Predict(const f32 *, f32 *);
	void Learn(const f32 *, f32 *, const f32 *, f32);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// NEURAL_H

// eof
