// QM2GUI.H : a graphical user interface for qm2-models.

// Copyright (C) 2000 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef QM2GUI_H
#define QM2GUI_H

#ifndef TARGET1

class qm2_gui;

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "guibase.h"
#include "qm2mdl.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

class qm2_gui : public bs_gui, public qm2_mdl
{
	public:
	
	public:
	
	qm2_gui(window_factory &, ostream *);
	~qm2_gui(void);
	
	const char * GetType(void);			// virtual
	color_mode * GetDefaultColorMode(void);		// virtual
	
	void SelectAll(void);				// virtual
	void InvertSelection(void);			// virtual
	
	void InitGL(void);			// virtual
	void Render(window *, rmode);		// virtual
	
	void Center(transformer *);			// virtual
	void Transform(transformer *);			// virtual
	
	void DrawEvent(window *, vector<iGLu> &);	// virtual
	void SelectEvent(window *, vector<iGLu> &);	// virtual
	
#ifdef TARGET2

	void KeyEvent(window *, char, int, int);	// virtual
	
#endif	// TARGET2

#ifdef TARGET3

	void PopupEvent(window *, int);		// virtual
	
#endif	// TARGET3

};

////////////////////////////////////////////////////////////////////////////////////////////////////

//fGL GetESPValue(fGL *, void *, fGL *);
//fGL GetSASValue(fGL *, void *, fGL *);

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// TARGET1
#endif	// QM2GUI_H

// eof
