// T2MAIN.CPP

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef TARGET2
#include "t2main.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

#define MODEL_QM1	0x0101
#define MODEL_QM2	0x0102

#define MODEL_MM1	0x0201
#define MODEL_MM2	0x0202
#define MODEL_MM3	0x0203

int main(int argc, char ** argv)
{
	cout << "Ghemical for GLUT" << endl;
	cout << "Version " << VERSION << " released on " << RELEASEDATE << endl;
	cout << endl;
	cout << "For more information please visit " << WEBSITE << endl;
	cout << endl;
	cout << "Copyright (C) 1998 Tommi Hassinen." << endl;
	cout << endl;
	cout << "This program is free software; you can redistribute it and/or" << endl;
	cout << "modify it under the terms of the GNU General Public License" << endl;
	cout << "as published by the Free Software Foundation; either version 2" << endl;
	cout << "of the License, or any later version." << endl;
	cout << endl;
	cout << "This program is distributed in the hope that it will be useful," << endl;
	cout << "but WITHOUT ANY WARRANTY; without even the implied warranty of" << endl;
	cout << "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the" << endl;
	cout << "GNU General Public License for more details." << endl;
	cout << endl;
	
	i32s mtype = MODEL_MM1;
	
	// add "double-buffer"-flag to the command line!??!?!?!
	// add "stereo"-flag to the command line (once it works in OGL/Mesa)!??!?!?!
	
	for (i32s n1 = 1;n1 < argc;n1++)
	{
		if (!strcmp(argv[n1], "-h") || !strcmp(argv[n1], "--help"))
		{
			cout << "command-line options:" << endl;
			cout << "---------------------" << endl;
			cout << endl;
			cout << "-m, --model : select the model" << endl;
			cout << "   q1 -> QM, atomic calculations" << endl;
			cout << "   q2 -> QM, molecular calculations" << endl;
			cout << "   m1 -> MM, \"all atoms\"-model (this is the default)" << endl;
			cout << endl;
			
			cout << "command-line help ???" << endl;
			return 0;
		}
		
		if ((!strcmp(argv[n1], "-m") || !strcmp(argv[n1], "--model")) && (++n1 < argc))
		{
			if (!strcmp(argv[n1], "q1")) mtype = MODEL_QM1;
			if (!strcmp(argv[n1], "q2")) mtype = MODEL_QM2;
			if (!strcmp(argv[n1], "m1")) mtype = MODEL_MM1;
		}
	}
	
	glutInit(& argc, argv);
	glutInitWindowPosition(10, 10);
	glutInitWindowSize(400, 400);
	
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_ACCUM | GLUT_DOUBLE);
	
	bs_gui * gui; glut_factory * gf = glut_factory::GetInstance();
	
	switch (mtype)
	{
		case MODEL_QM1:
		gui = new qm1_gui(* gf, & cout);
		break;
		
		case MODEL_QM2:
		gui = new qm2_gui(* gf, & cout);
		break;
		
		case MODEL_MM1:
		gui = new mm1_gui(* gf, & cout);
		break;
		
		default:
		cout << "something went wrong..." << endl;
		return 0;
	}
	
	gui->AddCamera(4.0);	// default focus ???
	
	cout << "model type is " << gui->GetType() << endl;
	cout << "press 'h' for help..." << endl;
	
	glutMainLoop();		// there is no return from this loop...
}

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// TARGET2

// eof
