// T2WINDOW.H : a view window class for GLUT.

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef T2WINDOW_H
#define T2WINDOW_H

#ifdef TARGET2

class glut_window;
class glut_factory;

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "window.h"

#include BEGIN_INCLUDE_STL	// this is compiler-dependent...
#include <vector>
#include END_INCLUDE_STL	// this is compiler-dependent...

////////////////////////////////////////////////////////////////////////////////////////////////////

class glut_window : public window
{
	private:
	
	int glut_id;
	
	void DisplayEvent(void);
	void KeyboardEvent(unsigned char, int, int);
	void SpecialEvent(int, int, int);
	
	static glut_window * GetWindow(int);
	
	static void DisplayHandler(void);
	static void KeyboardHandler(unsigned char, int, int);
	static void SpecialHandler(int, int, int);
	
	static void ReshapeHandler(int, int);
	
	static void MouseHandler(int, int, int, int);
	static void MotionHandler(int, int);
	
	static vector<glut_window *> glut_vector;
	
	public:
	
	glut_window(bs_gui *, camera *);
	~glut_window(void);
	
	void SetCurrent(void);			// virtual
	void SetTitle(const char *);		// virtual
	
	void Update(bool);		// virtual
};

////////////////////////////////////////////////////////////////////////////////////////////////////

class glut_factory : public window_factory
{
	private:
	
	static glut_factory * instance;
	glut_factory(void);
	
	public:
	
	~glut_factory(void);
	static glut_factory * GetInstance(void);
	
	window * Produce(bs_gui *, camera *);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// TARGET2
#endif	// T2WINDOW_H

// eof
